<?php

namespace Drupal\site_settings_domain\Hook;

use Drupal\Core\Hook\Attribute\Hook;
use Drupal\site_settings\Form\SiteSettingEntityForm;
use Drupal\site_settings_domain\Form\SiteSettingEntityDomainForm;
use Drupal\site_settings_domain\SiteSettingEntityDomainAccessControlHandler;

/**
 * Hooks onto entity_info_alter events.
 */
final class EntityTypeAlter {

  #[Hook('entity_type_alter')]
  public function alterSiteSettingEntity(array &$entity_types): void {
    /** @var \Drupal\Core\Entity\EntityTypeInterface[] $entity_types */
    $classes = $entity_types['site_setting_entity']->getHandlerClasses();
    foreach ($classes['form'] as &$class) {
      if ($class !== SiteSettingEntityForm::class) {
        continue;
      }

      $class = SiteSettingEntityDomainForm::class;
    }

    $entity_types['site_setting_entity']->setHandlerClass('access', SiteSettingEntityDomainAccessControlHandler::class);
    $entity_types['site_setting_entity']->setHandlerClass('form', $classes['form']);
  }

}
